package com.izouma.nineth.web;
import com.izouma.nineth.domain.Coupon;
import com.izouma.nineth.service.CouponService;
import com.izouma.nineth.dto.PageQuery;
import com.izouma.nineth.exception.BusinessException;
import com.izouma.nineth.repo.CouponRepo;
import com.izouma.nineth.utils.ObjUtils;
import com.izouma.nineth.utils.excel.ExcelUtils;
import lombok.AllArgsConstructor;
import org.springframework.data.domain.Page;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.util.List;

@RestController
@RequestMapping("/coupon")
@AllArgsConstructor
public class CouponController extends BaseController {
    private CouponService couponService;
    private CouponRepo couponRepo;

    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/save")
    public Coupon save(@RequestBody Coupon record) {
        if (record.getId() != null) {
            Coupon orig = couponRepo.findById(record.getId()).orElseThrow(new BusinessException("无记录"));
            ObjUtils.merge(orig, record);
            return couponRepo.save(orig);
        }
        return couponRepo.save(record);
    }


    //@PreAuthorize("hasRole('ADMIN')")
    @PostMapping("/all")
    public Page<Coupon> all(@RequestBody PageQuery pageQuery) {
        return couponService.all(pageQuery);
    }

    @GetMapping("/get/{id}")
    public Coupon get(@PathVariable Long id) {
        return couponRepo.findById(id).orElseThrow(new BusinessException("无记录"));
    }

    @PostMapping("/del/{id}")
    public void del(@PathVariable Long id) {
        couponRepo.softDelete(id);
    }

    @GetMapping("/excel")
    @ResponseBody
    public void excel(HttpServletResponse response, PageQuery pageQuery) throws IOException {
        List<Coupon> data = all(pageQuery).getContent();
        ExcelUtils.export(response, data);
    }
}

